"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
const common_1 = require("@nestjs/common");
const models_1 = require("../models");
const logger_service_1 = require("../services/logger.service");
const exceptions_1 = require("../exceptions");
const notification_service_1 = require("../services/notification.service");
const rxjs_1 = require("rxjs");
let NotificationController = class NotificationController {
    constructor(notificationSvc, loggerEnabled) {
        this.notificationSvc = notificationSvc;
        this.logger = new logger_service_1.Logger('Notification Controller', loggerEnabled);
    }
    send(email) {
        this.logger.log(`Send Email`, email);
        return this.notificationSvc.sendEmail(email.email, email.subject, email.text, email.attachment, email.html);
    }
};
__decorate([
    common_1.Post('send'),
    __param(0, common_1.Body()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [models_1.EmailRequestDTO]),
    __metadata("design:returntype", rxjs_1.Observable)
], NotificationController.prototype, "send", null);
NotificationController = __decorate([
    common_1.Controller('notification'),
    common_1.UseInterceptors(exceptions_1.ErrorsInterceptor),
    common_1.UseFilters(exceptions_1.ErrorFilter),
    __param(1, common_1.Inject('loggerEnabled')), __param(1, common_1.Optional()),
    __metadata("design:paramtypes", [notification_service_1.NotificationService, Boolean])
], NotificationController);
exports.NotificationController = NotificationController;
