"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
const common_1 = require("@nestjs/common");
const logger_service_1 = require("../services/logger.service");
const proxy_service_1 = require("../services/proxy.service");
const operators_1 = require("rxjs/operators");
const rxjs_1 = require("rxjs");
const exceptions_1 = require("../exceptions");
let ProxyController = class ProxyController {
    constructor(proxySvc, loggerEnabled) {
        this.proxySvc = proxySvc;
        this.logger = new logger_service_1.Logger('Proxy Controller', loggerEnabled);
    }
    get(url) {
        this.logger.log(`Proxied get`, url);
        return this.proxySvc.get(url).pipe(operators_1.map(response => {
            this.logger.log(response.data);
            return response;
        }), operators_1.catchError(error => {
            this.logger.error(error);
            return rxjs_1.of(new exceptions_1.BadRequestException('Could not proxy data.'));
        }));
    }
};
__decorate([
    common_1.Get(':url'),
    __param(0, common_1.Param('url')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String]),
    __metadata("design:returntype", rxjs_1.Observable)
], ProxyController.prototype, "get", null);
ProxyController = __decorate([
    common_1.Controller('proxy'),
    common_1.UseInterceptors(exceptions_1.ErrorsInterceptor),
    common_1.UseFilters(exceptions_1.ErrorFilter),
    __param(1, common_1.Inject('loggerEnabled')), __param(1, common_1.Optional()),
    __metadata("design:paramtypes", [proxy_service_1.ProxyService, Boolean])
], ProxyController);
exports.ProxyController = ProxyController;
