"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
const common_1 = require("@nestjs/common");
const models_1 = require("../models");
const logger_service_1 = require("../services/logger.service");
const exceptions_1 = require("../exceptions");
const report_service_1 = require("../services/report.service");
const rxjs_1 = require("rxjs");
let ReportController = class ReportController {
    constructor(reportSvc, loggerEnabled) {
        this.reportSvc = reportSvc;
        this.logger = new logger_service_1.Logger('Report Controller', loggerEnabled);
    }
    create(email) {
        this.logger.log(`Send Report`, email);
        return this.reportSvc.createReport(email.email, email.subject, email.text, email.html, email.attachment, email.params);
    }
    download(pdf, res) {
        this.logger.log(`Download Report`, pdf.attachment.filename);
        this.reportSvc.downloadReport(pdf.attachment, pdf.params).subscribe(resp => {
            res.download(resp.message);
        });
    }
};
__decorate([
    common_1.Post('create'),
    __param(0, common_1.Body()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [models_1.ReportRequestDTO]),
    __metadata("design:returntype", rxjs_1.Observable)
], ReportController.prototype, "create", null);
__decorate([
    common_1.Post('download'),
    common_1.Header('Content-Type', 'application/pdf'),
    __param(0, common_1.Body()), __param(1, common_1.Res()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [models_1.DownloadReportRequestDTO, Object]),
    __metadata("design:returntype", void 0)
], ReportController.prototype, "download", null);
ReportController = __decorate([
    common_1.Controller('report'),
    common_1.UseInterceptors(exceptions_1.ErrorsInterceptor),
    common_1.UseFilters(exceptions_1.ErrorFilter),
    __param(1, common_1.Inject('loggerEnabled')), __param(1, common_1.Optional()),
    __metadata("design:paramtypes", [report_service_1.ReportService, Boolean])
], ReportController);
exports.ReportController = ReportController;
