"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
const common_1 = require("@nestjs/common");
const exceptions_1 = require("../exceptions");
const decorators_1 = require("../decorators");
const users_service_1 = require("../services/users.service");
const services_1 = require("../services");
const models_1 = require("../models");
const rxjs_1 = require("rxjs");
let UsersController = class UsersController {
    constructor(userSvc, loggerEnabled) {
        this.userSvc = userSvc;
        this.logger = new services_1.Logger('User Controller', loggerEnabled);
    }
    uncompleted(token) {
        this.logger.log('Uncompleted user requested', token);
        return this.userSvc.uncompleted(token);
    }
    confirm(token, id, user) {
        this.logger.log('Complete user', token);
        return this.userSvc.confirm(id, user, token);
    }
    add(invited) {
        this.logger.log(`User Invited`, invited);
        return this.userSvc.invite(invited);
    }
    recover(email) {
        this.logger.log(`User Recovered`, email);
        return this.userSvc.recover(email);
    }
};
__decorate([
    common_1.Get('uncompleted'),
    __param(0, decorators_1.User()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String]),
    __metadata("design:returntype", rxjs_1.Observable)
], UsersController.prototype, "uncompleted", null);
__decorate([
    common_1.Post('confirm'),
    __param(0, decorators_1.User()), __param(1, common_1.Query('id')), __param(2, common_1.Body()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String, String, models_1.UserDTO]),
    __metadata("design:returntype", rxjs_1.Observable)
], UsersController.prototype, "confirm", null);
__decorate([
    common_1.Post('add'),
    __param(0, common_1.Body()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object]),
    __metadata("design:returntype", rxjs_1.Observable)
], UsersController.prototype, "add", null);
__decorate([
    common_1.Get('recover'),
    __param(0, common_1.Query('email')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object]),
    __metadata("design:returntype", rxjs_1.Observable)
], UsersController.prototype, "recover", null);
UsersController = __decorate([
    common_1.Controller('users'),
    common_1.UseInterceptors(exceptions_1.ErrorsInterceptor),
    common_1.UseFilters(exceptions_1.ErrorFilter),
    __param(1, common_1.Inject('loggerEnabled')), __param(1, common_1.Optional()),
    __metadata("design:paramtypes", [users_service_1.UserService, Boolean])
], UsersController);
exports.UsersController = UsersController;
