import { Observable } from 'rxjs';
import { Database } from '3a-common';
export declare class DynamoService implements Database.DatabaseService {
    private dynamo;
    private logger;
    constructor(AWS: any, loggerEnabled: boolean);
    get<T>(id: string, collection?: Database.Collection, attribute?: string): Observable<T>;
    save<T>(data: T, collection: Database.Collection, merge?: boolean): Observable<T>;
    batchGet<T>(ids: string[][], collections?: Database.Collection[]): Observable<{
        [_: string]: T[];
    }>;
    find<T>(queries: Database.DatabaseQuery[], collection?: Database.Collection, exclusiveStartKey?: AWS.DynamoDB.DocumentClient.Key): Observable<T[]>;
    slice<T>(queries: Database.DatabaseQuery[], collection?: Database.Collection, exclusiveStartKey?: AWS.DynamoDB.DocumentClient.Key): Observable<T[]>;
}
