"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
const common_1 = require("@nestjs/common");
const rxjs_1 = require("rxjs");
const operators_1 = require("rxjs/operators");
class UnauthorizedException extends common_1.HttpException {
    constructor(message) {
        super({
            success: false,
            message: `Operation not authorized: ${message}`
        }, common_1.HttpStatus.UNAUTHORIZED);
        console.error(`[${new Date().toUTCString()}] Error: Operation not authorized.`, message);
    }
}
exports.UnauthorizedException = UnauthorizedException;
class NotFoundException extends common_1.HttpException {
    constructor(message) {
        super({
            success: false,
            message: `Resource not found: ${message}`
        }, common_1.HttpStatus.NOT_FOUND);
    }
}
exports.NotFoundException = NotFoundException;
class BadRequestException extends common_1.HttpException {
    constructor(message, request) {
        super({
            success: false,
            message: `Bad Request: ${message}`
        }, common_1.HttpStatus.BAD_REQUEST);
        console.error(`[${new Date().toUTCString()}] Error: Bad Request.`, request);
    }
}
exports.BadRequestException = BadRequestException;
let ErrorsInterceptor = class ErrorsInterceptor {
    intercept(context, call$) {
        return call$.pipe(operators_1.catchError(err => {
            if (err.getStatus) {
                return rxjs_1.throwError(err);
            }
            else {
                return rxjs_1.throwError(new common_1.HttpException(err, common_1.HttpStatus.BAD_GATEWAY));
            }
        }));
    }
};
ErrorsInterceptor = __decorate([
    common_1.Injectable()
], ErrorsInterceptor);
exports.ErrorsInterceptor = ErrorsInterceptor;
let ErrorFilter = class ErrorFilter {
    catch(error, host) {
        const response = host.switchToHttp().getResponse();
        const status = (error instanceof common_1.HttpException) ? error.getStatus() : common_1.HttpStatus.INTERNAL_SERVER_ERROR;
        const message = error.stack;
        console.error(error);
        return response.status(status).send(message);
    }
};
ErrorFilter = __decorate([
    common_1.Catch()
], ErrorFilter);
exports.ErrorFilter = ErrorFilter;
