"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const common_1 = require("@nestjs/common");
const exceptions_1 = require("../exceptions");
let I3AMAuthenticatedMiddleware = class I3AMAuthenticatedMiddleware {
    constructor(cognito) {
        this.cognito = cognito;
    }
    resolve(optional) {
        return __awaiter(this, void 0, void 0, function* () {
            return (req, res, next) => __awaiter(this, void 0, void 0, function* () {
                const accessTokenFromClient = req.headers.authorization.split('Bearer ').join('');
                if (!accessTokenFromClient) {
                    throw new exceptions_1.UnauthorizedException('Cannot access this resource. Access Token missing from header');
                }
                this.cognito.validate(accessTokenFromClient, (err, response) => {
                    if (err) {
                        if (optional) {
                            req.user = accessTokenFromClient;
                        }
                        else {
                            req.user = undefined;
                        }
                        next();
                    }
                    else {
                        req.user = response;
                        next();
                    }
                });
            });
        });
    }
};
I3AMAuthenticatedMiddleware = __decorate([
    common_1.Injectable(),
    __param(0, common_1.Inject('cognito')),
    __metadata("design:paramtypes", [Object])
], I3AMAuthenticatedMiddleware);
exports.I3AMAuthenticatedMiddleware = I3AMAuthenticatedMiddleware;
