import { Resource, Auth, Database } from '3a-common';
export declare class ResourceDTO implements Resource {
    readonly id: string;
    readonly name: string;
    readonly resourceID: string;
    readonly disabled?: boolean;
    readonly tableName?: string;
    readonly type?: number;
}
export declare class UserDTO extends ResourceDTO implements Auth.User {
    readonly email?: string;
    readonly roles?: string[];
    readonly permissions?: Auth.Permission[];
    readonly username?: string;
    readonly lastAccess?: number;
    readonly lastDevice?: Auth.UserDevice;
    readonly nit?: string;
}
export declare class RoleDTO extends ResourceDTO implements Auth.Role {
    readonly description?: string;
    readonly permissions?: Auth.Permission[];
    readonly users?: string[];
}
export declare class DatabaseQueryDTO implements Database.DatabaseQuery {
    key: string;
    relation: Database.DatabaseQueryRelation;
    value?: any;
}
export declare class DatabaseCollectionDTO implements Database.Collection {
    readonly name: string;
    readonly index?: string;
}
export declare class DatabaseBatchDTO {
    ids: string[][];
    collections: DatabaseCollectionDTO[];
}
export declare class EmailRequestDTO {
    email: string;
    subject: string;
    text: string;
    html?: string;
    attachment?: AttachmentRequestDTO;
}
export declare class AttachmentRequestDTO {
    filename: string;
    path: string;
}
export declare class ReportRequestDTO {
    email: string;
    subject: string;
    text: string;
    html?: string;
    attachment?: AttachmentRequestDTO;
    params?: JSON;
}
export declare class DownloadReportRequestDTO {
    attachment?: AttachmentRequestDTO;
    params?: JSON;
}
