import { Observable } from 'rxjs';
import { DatabaseQueryDTO, UserDTO } from '../models';
import { Database, Resource } from '3a-common';
export declare class ServerDatabaseService {
    private readonly db;
    constructor(db: Database.DatabaseService);
    get<T>(id: string, collection?: Database.Collection): Observable<T>;
    save<T>(data: T, collection?: Database.Collection): Observable<T>;
    batchGet<T extends Resource>(ids: string[][], collections?: Database.Collection[], user?: UserDTO): Observable<{
        [key: string]: T[];
    }>;
    find<T extends Resource>(queries: DatabaseQueryDTO[], collection?: Database.Collection, user?: UserDTO): Observable<T[]>;
    slice<T extends Resource>(queries: DatabaseQueryDTO[], collection?: Database.Collection, user?: UserDTO): Observable<T[]>;
}
