"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
const common_1 = require("@nestjs/common");
const rxjs_1 = require("rxjs");
const _3a_common_1 = require("3a-common");
const operators_1 = require("rxjs/operators");
const methods_1 = require("../models/methods");
let ServerDatabaseService = class ServerDatabaseService {
    constructor(db) {
        this.db = db;
    }
    get(id, collection) {
        return this.db.get(id, collection);
    }
    save(data, collection) {
        return this.db.save(data, collection);
    }
    batchGet(ids, collections, user) {
        return this.db.batchGet(ids, collections).pipe(operators_1.switchMap(data => {
            if (user && user.roles) {
                return this.db.batchGet([user.roles], [{ name: 'Roles' }]).pipe(operators_1.map(result => {
                    const roles = result.Roles;
                    const allUserPermissions = user.permissions ? user.permissions.slice() : [];
                    for (const role of roles) {
                        allUserPermissions.push(...role.permissions);
                    }
                    for (const key in data) {
                        if (data.hasOwnProperty(key)) {
                            const items = data[key];
                            if (items && items.length > 0 && items[0] && 'resourceID' in items[0] && user) {
                                const itemsResourcesIds = items.map(item => item.resourceID).filter(item => !!item);
                                const allowedActions = methods_1.withPermissionsCanPerformAction(itemsResourcesIds, allUserPermissions, 'read');
                                data[key] =
                                    items.filter(item => !item.disabled && allowedActions.indexOf(item.resourceID) >= 0);
                            }
                            else {
                                data[key] = items;
                            }
                        }
                    }
                    return data;
                }));
            }
            else {
                for (const key in data) {
                    if (data.hasOwnProperty(key)) {
                        const items = data[key];
                        if (items && items.length > 0 && items[0] && 'resourceID' in items[0] && user) {
                            const itemsResourcesIds = items.map(item => item.resourceID).filter(item => !!item);
                            const allowedActions = methods_1.withPermissionsCanPerformAction(itemsResourcesIds, user.permissions ? user.permissions : [], 'read');
                            data[key] =
                                items.filter(item => !item.disabled && allowedActions.indexOf(item.resourceID) >= 0);
                        }
                        else {
                            data[key] = items;
                        }
                    }
                }
                return rxjs_1.of(data);
            }
        }));
    }
    find(queries, collection, user) {
        const isCollection = (cn, test) => {
            return cn.name === test;
        };
        return this.db.find(queries, collection).pipe(operators_1.switchMap(items => {
            if (!isCollection(collection, 'Users') &&
                !isCollection(collection, 'Organizations') &&
                !isCollection(collection, 'Plans') &&
                items && items.length > 0 && items[0] &&
                'resourceID' in items[0] && user) {
                const itemsResourcesIds = items.map(item => item.resourceID).filter(item => !!item);
                return methods_1.CanUserPerformAction(this.db, itemsResourcesIds, user, 'read')
                    .pipe(operators_1.map((allowedItemsId) => {
                    return items.filter(item => !item.disabled && allowedItemsId.indexOf(item.resourceID) >= 0);
                }));
            }
            else {
                return rxjs_1.of(items);
            }
        }));
    }
    slice(queries, collection, user) {
        const isCollection = (cn, test) => {
            return cn.name === test;
        };
        return this.db.slice(queries, collection).pipe(operators_1.switchMap(items => {
            if (!isCollection(collection, 'Prescriptions_Boards') &&
                items && items.length > 0 && items[0] && 'resourceID' in items[0] && user) {
                const itemsResourcesIds = items.map(item => item.resourceID).filter(item => !!item);
                return methods_1.CanUserPerformAction(this.db, itemsResourcesIds, user, 'read')
                    .pipe(operators_1.map((allowedItemsId) => {
                    return items.filter(item => !item.disabled && allowedItemsId.indexOf(item.resourceID) >= 0);
                }));
            }
            else {
                return rxjs_1.of(items);
            }
        }));
    }
};
ServerDatabaseService = __decorate([
    common_1.Injectable(),
    __param(0, common_1.Inject('database')),
    __metadata("design:paramtypes", [_3a_common_1.Database.DatabaseService])
], ServerDatabaseService);
exports.ServerDatabaseService = ServerDatabaseService;
