"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
class Logger {
    constructor(context = 'Server', enabled = false) {
        this.context = context;
        this.enabled = enabled;
    }
    log(message, payload, context = 'Server') {
        if (this.enabled) {
            console.log(`[${new Date().toUTCString()}] [${context || this.context}]: ${message}.`);
            if (payload) {
                console.log(`Payload: `, payload);
                console.log('---------------------------------------------');
            }
        }
    }
    error(message, payload, context = 'Server') {
        console.error(`[${new Date().toUTCString()}] [${context || this.context}] (Error): ${message}.`);
        if (payload) {
            console.log(`Payload: `, payload);
            console.log('---------------------------------------------');
        }
    }
}
exports.Logger = Logger;
