import { Resource, Database, ResourceTree } from '3a-common';
import { Observable } from 'rxjs';
import { UserDTO, AppConfig } from '../models';
import { ResourceNavigationService } from './navigation.service';
export declare class ResourceService {
    private readonly db;
    private readonly appConfig;
    private readonly navigationService;
    constructor(db: Database.DatabaseService, appConfig: AppConfig, navigationService: ResourceNavigationService);
    getAll(user: UserDTO): Observable<ResourceTree>;
    get<T extends Resource>(id: string, user: UserDTO, collection?: Database.Collection, attribute?: string): Observable<T>;
    save<T extends Resource>(data: T, user?: UserDTO, merge?: boolean, parentResourceID?: string): Observable<T>;
}
