"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
const common_1 = require("@nestjs/common");
const moment = require("moment");
const uuid = require("uniqid");
const crypto = require("crypto");
const algorithm = 'aes-256-cbc';
let SecurityService = class SecurityService {
    constructor() {
        this.permanentPassword = 'X$@YsB,vE"pmm^&7M@muq3^Da^>94X;[';
        this.IV_LENGTH = 16;
    }
    encrypt(text) {
        const iv = crypto.randomBytes(this.IV_LENGTH);
        const cipher = crypto.createCipheriv(algorithm, new Buffer(this.permanentPassword), iv);
        const crypted = cipher.update(`3ASECURITY_CYPHER::${text}`, 'utf8', 'hex') + cipher.final('hex');
        return iv.toString('hex') + ':' + crypted;
    }
    decrypt(text) {
        try {
            const segments = text.split(':');
            const iv = new Buffer(segments.shift(), 'hex');
            const encryptedText = segments.join(':');
            const decipher = crypto.createDecipheriv(algorithm, new Buffer(this.permanentPassword), iv);
            const original = decipher.update(encryptedText, 'hex', 'utf8') + decipher.final('utf8');
            if (original.indexOf('3ASECURITY_CYPHER::') > -1) {
                return original.split('3ASECURITY_CYPHER::').join('');
            }
            else {
                return '';
            }
        }
        catch (error) {
            console.error('Decypher could not complete.');
            return '';
        }
    }
    dynamicEncrypt(text) {
        if (!this.dynamicPassword) {
            this.dynamicPassword = uuid();
            this.exipresAfter = moment().utc().add(15, 'm').valueOf();
        }
        else {
            const current = moment().utc().valueOf();
            if (current >= this.exipresAfter) {
                this.dynamicPassword = uuid();
                this.exipresAfter = moment().utc().add(15, 'm').valueOf();
            }
        }
        const iv = crypto.randomBytes(this.IV_LENGTH);
        const cipher = crypto.createCipheriv(algorithm, this.dynamicPassword, iv);
        let crypted = cipher.update(`3ASECURITY_CYPHER::${text}`, 'utf8', 'hex');
        crypted += cipher.final('hex');
        return crypted;
    }
    dynamycDecrypt(text) {
        if (!this.dynamicPassword) {
            return undefined;
        }
        else {
            const segments = text.split(':');
            const iv = new Buffer(segments.shift(), 'hex');
            const encryptedText = segments.join(':');
            const decipher = crypto.createDecipheriv(algorithm, this.dynamicPassword, iv);
            const original = decipher.update(encryptedText, 'hex', 'utf8') + decipher.final('utf8');
            if (original.indexOf('3ASECURITY_CYPHER::') > -1) {
                return original.split('3ASECURITY_CYPHER::').join('');
            }
            else {
                return undefined;
            }
        }
    }
};
SecurityService = __decorate([
    common_1.Injectable()
], SecurityService);
exports.SecurityService = SecurityService;
