import { Observable } from 'rxjs';
import { APIResponse, Database, Auth } from '3a-common';
import { NotificationService } from './notification.service';
import { SecurityService } from './security.service';
import { UserDTO, AppConfig } from '../models';
export declare class UserService {
    protected notificationSvc: NotificationService;
    protected security: SecurityService;
    protected readonly appConfig: AppConfig;
    protected readonly database: Database.DatabaseService;
    private logger;
    constructor(notificationSvc: NotificationService, security: SecurityService, appConfig: AppConfig, database: Database.DatabaseService, loggerEnabled: boolean);
    invite(user: UserDTO): Observable<APIResponse>;
    uncompleted(token: string): Observable<Auth.User>;
    confirm(userID: string, user: UserDTO, token: string): Observable<any>;
    recover(email: string): Observable<APIResponse>;
}
